#ifndef PUBLIKUSSZEMELY_H_INCLUDED
#define PUBLIKUSSZEMELY_H_INCLUDED

//PublikusAdat class, itt vannak trolva a publikus adatok:
//Teljes nv, munkai telefonszm
class PublikusAdat {
    String nev;
    String munksz;
public:
    //Default konstruktor, mindent "0"-ra llt alaphelyzetben
    PublikusAdat(): nev("0"), munksz("0"){}

    //Konstruktor
    PublikusAdat(String nev, String munksz): nev(nev), munksz(munksz) {}

    //Copy konstruktor
    PublikusAdat(const PublikusAdat& dt){
        nev = dt.nev;
        munksz = dt.munksz;
    }

    //Egyenlsget vizsgl opertor,
    //igazzal tr vissza ha minden PublikusAdat tag megegyezik
    //egybknt pedig hamissal
    bool operator==(const PublikusAdat& tbc){
        if (nev == tbc.nev && munksz == tbc.munksz){
            return true;
        }
        return false;
    }

    //Egyenlsg opertor,
    //Mindegyik adatot, a megadott tpussal teszi egyenlv
    PublikusAdat& operator=(const PublikusAdat& kok){
        nev = kok.nev;
        munksz = kok.munksz;
        return *this;
    }

    //Fggvny, ami visszaadja a teljes nv adattagot
    const String& getpubnev(){
        return this->nev;
    }

    //Fggvny, ami visszaadja a munkai telefonszmot
    const String& getmunksz(){
        return this->munksz;
    }
};

#endif // PUBLIKUSSZEMELY_H_INCLUDED
