#ifndef VICTOR_H_INCLUDED
#define VICTOR_H_INCLUDED

#include <iostream>
#include <fstream>

#include "element.h"
#include "string5.h"

//generikus tomb amiben egy lncolt listban
//trolva vannak az adatok
template<class T>

//Class amiben az Element class-t troljuk, azrt szuksges,
//hogy lncolt listval sszefzhetek legyenek az adattagok
class victor
{
    //Az els elemre mutat pointer
    Element<T>* firstElement;
public:

    //Konstruktor, alapbl NULL-ra lltja az els elemet
    victor() :firstElement(NULL) {}

    //Elemet trl fggvny
    void deleteElement(int index)
    {
         //Elz elemre mutat pointer, alaphelyzetben ez NULL
         Element<T>* prev = NULL;

         //Segd pointer
         Element<T>* helper = NULL;

         //Temporary pointer, ami alaphelyzetben az els elemre mutat
         Element<T>* temp = firstElement;

         //Ciklus, ami elviszi a temp pointert addig,
         //amg az nem a indexel megadott elemre mutat
         for(int i = 0; i!=index;i++) {
            prev = temp;
            temp = temp->next;
         }

         //Megvizsglja, hogy a temp nem NULL-e,
         //ha igen kilp a fggvnybl, mert nincs teend
         if (temp == NULL) {
            return;
         }

         //Egybknt megvizsglja, hogy nem e az els elem az ami meg van adva,
         //ha igen, akkor trli azt, s a helperrel az els elemet az a temp->nextre lltja
         else {
            if(prev == NULL) {
                helper = temp->next;
                delete temp;
                firstElement = helper;
            }

            //Ha nem az els, akkor az elz next pointert az adott next pointerre lltja,
            // s trli az adatot
            else {
                prev->next = temp->next;
                delete temp;
            }
         }
        return;
    }

    //Elemet hozzad fggvny
    void addElement(T element) {

        //Megvizsglja, hogy ltezik-e els element,
        //ha nem a hozzadott lesz az
        if (firstElement == NULL) {
            firstElement = new Element<T>(element);
        }

        //Egybknt pedig elmegy a lista vgig, s oda illeszti be az elemet
        else {
            Element<T>* temp = firstElement;
            while (temp->next != NULL) {
                temp = temp->next;
            }
            temp->next = new Element<T>(element);
        }
    }

    //Fggvny, ami megkeresi az adott index elemet
    T getElementAt(int index) {
        Element<T>* temp = firstElement;
        int i = 0;
        //Az adott elemig elmegy a fggvny,
        //s gy a temp vltoz a keresett rtk lesz
        while (i<index) {
            temp = temp->next;
            i++;
        }
        //Visszatr a keresett element Value-jval
        return temp->getValue();
    }

    //Fggvny, ami kirja consolba az eddig felvett adatoknak a PublikusAdat adattagjait
    void kiir(){
        Element<T>* temp = firstElement;
        //Ha nincs mg elem a listban nem lehet kiiratni
        if (temp == NULL){
            std::cout<<"Nincs adat, nem listazhatsz"<<std::endl;
        }
        //Egybknt vgig megy az adatok, s krja a PublikusAdatokat
        else{
            while (temp != NULL) {
                std::cout<<temp->getValue().getpubad().getpubnev()<<" ";
                std::cout<<temp->getValue().getpubad().getmunksz()<<std::endl;
                temp = temp->next;
            }
        }
    }

    //Kln kirs a tesztnek
    //Kb. ugyangy r ki mint a fjlba
    void testkiir(std::ostream& out) const{
        Element<T>* temp = firstElement;
        if (temp == NULL){
            out<<"Nincs adat, nem listazhatsz"<<std::endl;
        }
        else{
            while (temp != NULL) {
                out<<temp->getValue().getpubad().getpubnev()<<" "
                <<temp->getValue().getpubad().getmunksz()<<" "
                <<temp->getValue().getpriv().getnev()<<" "
                <<temp->getValue().getpriv().getcim()<<" "
                <<temp->getValue().getpriv().getprivatsz()<<"\n";
                temp = temp->next;
            }
        }
    }

    //Fjlba kir fggvny
    void fkiiras() const{
        Element<T>* temp = firstElement;
        //Ha nincs mg elem a listban nem lehet fjlba rni
        if (temp == NULL){
            std::cout<< "Nincs adat, igy nem irhatsz fajlba" <<std::endl;
        }

        //Egybknt kir minden adatot a fjlba kln sorokban
        else{
                std::ofstream fajl("adatok.txt");
                if (!fajl){
                    return;
                }
                //Ciklus ami vgig megy az adatokon a kiirats sorn
                while (temp != NULL){
                    fajl<<temp->getValue().getpubad().getpubnev()<<"\n"<<temp->getValue().getpubad().getmunksz()<<"\n"<<
                    temp->getValue().getpriv().getnev()<<"\n"<<temp->getValue().getpriv().getcim()<<"\n"<<temp->getValue().getpriv().getprivatsz()<<"\n";
                    temp = temp->next;
                }
                fajl.close();
                std::cout << "A fajlba iras sikeres volt" << std::endl;
        }
    }

    void testfkiiras(std::ostream& out) const{
        Element<T>* temp = firstElement;
        //Ha nincs mg elem a listban nem lehet fjlba rni
        if (temp == NULL){
            out<< "Nincs adat, igy nem irhatsz fajlba" <<std::endl;
        }

        //Egybknt kir minden adatot a fjlba kln sorokban
        else{
                std::ofstream fajl("adatok.txt");
                if (!fajl){
                    return;
                }
                //Ciklus ami vgig megy az adatokon a kiirats sorn
                while (temp != NULL){
                    fajl<<temp->getValue().getpubad().getpubnev()<<"\n"<<temp->getValue().getpubad().getmunksz()<<"\n"<<
                    temp->getValue().getpriv().getnev()<<"\n"<<temp->getValue().getpriv().getcim()<<"\n"<<temp->getValue().getpriv().getprivatsz()<<"\n";
                    temp = temp->next;
                }
                fajl.close();
                out << "A fajlba iras sikeres volt" << std::endl;
        }
    }

    //vCardba kir fggvny
    void vCardkiiras() const{
        Element<T>* temp = firstElement;
        //Ha nincs mg elem a listban nem lehet vCardba rni
        if (temp == NULL){
            std::cout<< "Nincs adat, nem tudsz vCardba irni"<< std::endl;
        }

        //Egybknt kir minden adatot egy vCard fjlba kln vCardnak helyes formtumba
        else {
            std::ofstream fajl("vCardAdatok.vcf");
            if (!fajl){
                return;
            }
            //Ciklus ami vgig megy az adatokon a kiirats sorn
            while (temp != NULL){
                fajl<< "BEGIN:VCARD\nVERSION:3.0\nN:" << temp->getValue().getpubad().getpubnev() << "\nFN:" << temp->getValue().getpriv().getnev() <<
                "\nADR;TYPE=home:;;" << temp->getValue().getpriv().getcim() << "\nTEL;TYPE=home:" << temp->getValue().getpriv().getprivatsz() << "\nTEL;TYPE=work:"
                << temp->getValue().getpubad().getmunksz()<< "\n";
                temp = temp->next;
            }
            fajl.close();
            std::cout << "A vCard fajlbairas sikeres volt" << std::endl;
        }

    }

    void testvCardkiiras(std::ostream& out) const{
        Element<T>* temp = firstElement;
        //Ha nincs mg elem a listban nem lehet vCardba rni
        if (temp == NULL){
            out<< "Nincs adat, nem tudsz vCardba irni"<< std::endl;
        }

        //Egybknt kir minden adatot egy vCard fjlba kln vCardnak helyes formtumba
        else {
            std::ofstream fajl("vCardAdatok.vcf");
            if (!fajl){
                return;
            }
            //Ciklus ami vgig megy az adatokon a kiirats sorn
            while (temp != NULL){
                fajl<< "BEGIN:VCARD\nVERSION:3.0\nN:" << temp->getValue().getpubad().getpubnev() << "\nFN:" << temp->getValue().getpriv().getnev() <<
                "\nADR;TYPE=home:;;" << temp->getValue().getpriv().getcim() << "\nTEL;TYPE=home:" << temp->getValue().getpriv().getprivatsz() << "\nTEL;TYPE=work:"
                << temp->getValue().getpubad().getmunksz()<< "\n";
                temp = temp->next;
            }
            fajl.close();
            out << "A vCard fajlbairas sikeres volt" << std::endl;
        }

    }

    //Fggvny ami trl minden adatot
    void clear(){
        //Ha nincs elem visszatr, nincs mit tennie
        if (firstElement == NULL) return;
        Element<T>* next = firstElement->next;
        Element<T>* temp = firstElement;
        //Ciklus ami vgig megy az elemeken s trli ket
        while (temp->next != NULL) {
            next = temp->next;
            delete temp;
            temp = next;
        }
        //Vgl az utols elemet is trl parancs
        delete temp;
    }

    //Destruktor, ami meghvja a clear() fggvnyt, s gy trl mindent
    ~victor(){
        if (firstElement!= NULL){
            clear();
        }
    }
};

#endif // VICTOR_H_INCLUDED
